summaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-06-11 00:57:36 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2012-06-11 00:57:36 +0000
commitaf491558a3344d5ae56a0b2163d552d026c3a1d3 (patch)
treeb848d45d53c717bd693cdc653d99b00ad8647216 /scripts
parent499d03c2f31d3530bc5d16e674f0ebe041276580 (diff)
build: add checks for missing package dependencies
git-svn-id: svn://svn.openwrt.org/openwrt/trunk@32185 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/gen-dependencies.sh24
1 files changed, 24 insertions, 0 deletions
diff --git a/scripts/gen-dependencies.sh b/scripts/gen-dependencies.sh
new file mode 100755
index 000000000..ab047b648
--- /dev/null
+++ b/scripts/gen-dependencies.sh
@@ -0,0 +1,24 @@
+#!/usr/bin/env bash
+#
+# Copyright (C) 2012 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+SELF=${0##*/}
+
+READELF="${READELF:-readelf}"
+TARGETS=$*
+XARGS="${XARGS:-xargs -r}"
+
+[ -z "$TARGETS" ] && {
+ echo "$SELF: no directories / files specified"
+ echo "usage: $SELF [PATH...]"
+ exit 1
+}
+
+find $TARGETS -type f -a -exec file {} \; | \
+ sed -n -e 's/^\(.*\):.*ELF.*\(executable\|shared object\).*,.* stripped/\1/p' | \
+ $XARGS -n1 readelf -d | \
+ awk '$2 ~ /NEEDED/ && $NF !~ /interpreter/ { gsub(/[\[\]]/, "", $NF); print $NF }' | \
+ sort -u